<!-- 车流量分析 -->
<template>
	<view class="revenue">
		<view class="revenue-line">
			<LineChart v-if="hasData" :chartData="chartData" :title="title" :opts="opts" />
			<view class="empty" v-else>
				<u-empty></u-empty>
			</view>
		</view>
	</view>
</template>

<script>
	import LineChart from '@/components/lineChart.vue'
	export default {
		components: {
			LineChart
		},
		props: {
			title: {
				type: String,
				default: ''
			},
			opts: {
				type: Object,
				default: () => {
					return {
						enableScroll: true,
						xAxis: {
							rotateLabel: true,
							scrollShow: true,
							itemCount: 8
						},
						yAxis: {
							showTitle: true,
							splitNumber: 5,
							data: [{
								title: '辆',
								titleOffsetY: -3
							}]
						},
						legend: {
							show: true
						},
						dataLabel: false,
						padding: [20, 10, 10, 10],
						extra: {
							column: {
								width: 20
							}
						}
					}
				}
			}
		},
		data() {
			return {
				chartData: {
					categories: [],
					series: []
				},
				reportType: '',
				queryDate: '',
				hasData: false
			}
		},
		methods: {
			getData({
				reportType,
				queryDate
			}) {
				this.chartData.categories = []
				this.chartData.series = []
				this.reportType = reportType
				this.queryDate = queryDate
				this.hasData = false;
				this.getRoadData({ reportType, queryDate });
			},
			getRoadData({ reportType, queryDate }) {
				uni.$u.api.operationalAnalysisApi.getTrafficFlowDataApi({
					reportType,
					queryDate
				}).then(res => {
					if (res.code === 200) {
						if (res.data.itemList && res.data.itemList.length) {
							this.chartData.series[0] = {
								name: '路段',
								data: []
							}
							this.chartData.categories = res.data.itemList.map(item => {
								return item.statisTime
							})
							this.chartData.series[0].data = res.data.itemList.map(item => {
								return item.vehicleCount
							})
						}
					}
					this.getParkingData({ reportType, queryDate });
				})
			},
			getParkingData({ reportType, queryDate }) {
				uni.$u.api.operationalAnalysisApi.getParkingTrafficFlowDataApi({
					reportType,
					queryDate
				}).then(res => {
					if (res.code === 200) {
						if (res.data.itemList && res.data.itemList.length) {
							if (this.chartData.series.length) {
								this.chartData.series[1] = {
									name: '停车场',
									data: []
								}
								this.chartData.series[1].data = res.data.itemList.map(item => {
									return item.vehicleCount
								})
							} else {
								this.chartData.series[0] = {
									name: '停车场',
									data: []
								}
								this.chartData.series[0].data = res.data.itemList.map(item => {
									return item.vehicleCount
								})
							}
							if (!this.chartData.categories.length) {
								this.chartData.categories = res.data.itemList.map(item => {
									return item.statisTime
								})
							}
							this.hasData = true
						} else if (this.chartData.series.length === 1) {
							this.hasData = true
						} else if (!this.chartData.series.length) {
							this.hasData = false
						}
					}
				})
			}
		}
	}
</script>

<style lang="scss" scoped>
	.revenue {
		background-color: #fff;
		border-radius: 5px;

		.empty {
			padding: 15px;
		}
	}
</style>
